*! version 1.0.0 July 24, 2006 @ 02:44:50
*! runs a keep, but ensures that all variables needed for validation (or other char testing) are kept
program define ckkeep, rclass
version 9
	syntax varlist, [what(str) listonly]
	if `"`what'"'=="" {
		local what "valid"
		}

	foreach self of local varlist {
		foreach which of local what {
			dolikedig `self', evalchar(`which'_check) datachar(`which'_other_vars_needed) accum
			local otherVarsNeeded "`otherVarsNeeded' `r(contents)' `r(visits)'"
			}
		}
	
	local otherVarsNeeded: list uniq otherVarsNeeded
	local extras: list otherVarsNeeded - varlist
	if "`extras'"!="" {
		display as text "Need to keep the following additional variables to make sure characteristic(s) " as input "`what'" as text " keep(s) functioning:"
		display as result " `extras'"
		}
	if "`listonly'"=="" {
		keep `otherVarsNeeded'
	   }
	return local needed `otherVarsNeeded'	

end
