*! version 1.0.0 July 21, 2006 @ 18:04:51
*! saves user input from editcheckvar dialog
program define ckvareditSave
version 9
	local myname "ckvareditSave"

	syntax varname, stub(str) req(str) rulechgflag(str) [rule(str) xvars(str)]

	if `"`xvars'"'!="" {
		unab xvars: `xvars', name("`myname'")
		char `varlist'[`stub'_other_vars_needed] `xvars'
		}
	
	
   if `req' {
		char `varlist'[`stub'_required] yes
		}
	else {
		local theChar: char `varlist'[`stub'_required]
		if `"`theChar'"'!="" {
			char `varlist'[`stub'_required]
			}
		}

	if `rulechgflag' {
/* alas... this fails in this direction... */
/* 		char `varlist'[`stub'_check] `"`macval(rule)'"' */
		if `"`rule'"'=="" {
			char `varlist'[`stub'_check]
			}
		else {
			local first: word 1 of `rule'
			if lower(`"`first'"') == "in" | lower(`"`first'"') == "like" {
				char `varlist'[`stub'_check] `rule'
				}
			else {
				display as text "`myname': did not save complex rule " as result "`rule'"
				}
			}
		}
   if !`c(changed)' {
		local theObs = _N + 1
		capture set obs `theObs'
		if _rc {
			display as result "`myname': be careful! Dataset not marked as changed!"
			exit
			}
		capture drop in l
	   if _rc {
			display as error "`myname': added an observation, but could not drop it! Last observation is fake!"
			exit 666
			}
	}	/* end check for changed */
end
